clear

tic
% Order
N=2;
% Length
M=5;
% Number of countries
K=2;
% Trade costs
T=0.2;
% Iceberg trade costs
iceberg=0;
% Shape parameter
shape=4.12;



% Number of simulations
S=10000000;

% Trade costs bounds 
T0=0;
T1=1;
% Number of graphs
NT=10;

XT=zeros(NT,1);

MC=zeros(S,NT);

tic
parfor s=1:S
    costs=cell(M,1);
for m=1:M
    x=rand(N^(m-1),K);
    x=1./((-log(x)).^(-1/shape));
    costs{m}=x;
end
    for t=1:NT
        T=T0+(t-1)*(T1-T0)/NT;
MC(s,t)=procedure_MC(costs,T,iceberg);
%XT(t)=T;
    end
   % progressbar(s/S);
end
toc

result=mean(mean(MC))

for t=1:NT
[DensityY(:,t),DensityX(:,t)]=ksdensity(transpose(MC(:,t)));
end

h=figure;
set(findobj(gca, 'Type', 'Line', 'Linestyle', '--'), 'LineWidth', 2);
plot(DensityX(:,1),DensityY(:,1),DensityX(:,2),DensityY(:,2),DensityX(:,3),DensityY(:,3),DensityX(:,4),DensityY(:,4),DensityX(:,5),DensityY(:,5),DensityX(:,6),DensityY(:,6),'LineWidth',2);
legend({'t=0' 't=0.2' 't=0.4' 't=0.6' 't=0.8' 't=1'},'Position',[0 0 0.2 0.2],'FontSize',12);
title('')
xlabel('MC')
ylabel('Density')

%set(h,'Units','Inches');
%pos = get(h,'Position');
%set(h,'PaperPositionMode','Auto','PaperUnits','Inches','PaperSize',[pos(3), pos(4)])
%print(h,'C:\Users\vtya5450\Dropbox (Sydney Uni)\AEJ_Revision\Figures\Figure 5','-dpdf','-r0')