tic

clear

for k=1:4

% Order    
N=2;
% Length
M=5;
% Number of countries
K=2+(k-1)*5;

% Shape parameter
shape=4.12;
% Trade costs
T=0.2;
% Iceber trade costs indicator
iceberg=1;

% Number of simulations
S1=100;
S2=1000;


% Trade costs boundaries
T0=0;
T1=1;
% Number of steps
ST=100;
TA=zeros(ST,1);

tshares=zeros(M-1,S1,ST);
for j=1:S1
shares=zeros(M-1,S2,ST);
for i=1:S2
costs=cell(M,1);
for m=1:M
    x=rand(N^(m-1),K);
    x=1./((-log(x)).^(-1/shape));
    costs{m}=x;
end
for t=1:ST
T=T0+((T1-T0)/ST)*(t-1);
shares(:,i,t)=fo_parents(N,M,K,T,iceberg,costs);
TA(t)=T;
end
end
tshares(:,j,:)=mean(shares,2);
progressbar(j/S1);
end
parents=mean(tshares,2);
k

parents5=prctile(tshares,5,2);
parents95=prctile(tshares,95,2);
results=[parents5 parents parents95];


parents_1(:,k)=squeeze(parents(1,:,:));
parents_2(:,k)=squeeze(parents(2,:,:));
parents_3(:,k)=squeeze(parents(3,:,:));
parents_4(:,k)=squeeze(parents(4,:,:));

parents5_1(:,k)=squeeze(parents5(1,:,:));
parents5_2(:,k)=squeeze(parents5(2,:,:));
parents5_3(:,k)=squeeze(parents5(3,:,:));
parents5_4(:,k)=squeeze(parents5(4,:,:));

parents95_1(:,k)=squeeze(parents95(1,:,:));
parents95_2(:,k)=squeeze(parents95(2,:,:));
parents95_3(:,k)=squeeze(parents95(3,:,:));
parents95_4(:,k)=squeeze(parents95(4,:,:));
end
toc


m=4;
hold on
h=figure;

fig=gcf;
fig.Units='normalized';
fig.OuterPosition=[0 0 1 1];
subplot(2,2,m)



% K=1
m=1;
subplot(2,2,m)
p=plot(TA', parents_1(:,m)',TA', parents_2(:,m)',TA', parents_3(:,m)',TA', parents_4(:,m)','LineWidth',1)
legend({'Most upstream stage pair','Second upstream stage pair','Third upstream stage pair','Most downstream stage pair'},'Location','southeast')
xlim([0 T1])
ylim([0.5 1])
title('K=2')
xlabel('Trade Costs')
ylabel('Share of Filial Nodes with the Same Location')

% K=2
m=2;
subplot(2,2,m)
p=plot(TA', parents_1(:,m)',TA', parents_2(:,m)',TA', parents_3(:,m)',TA', parents_4(:,m)','LineWidth',1)
legend({'Most upstream stage pair','Second upstream stage pair','Third upstream stage pair','Most downstream stage pair'},'Location','southeast')
xlim([0 T1])
ylim([1/7 1])
title('K=7')
xlabel('Trade Costs')
ylabel('Share of Filial Nodes with the Same Location')



% K=2
m=3;
subplot(2,2,m)
p=plot(TA', parents_1(:,m)',TA', parents_2(:,m)',TA', parents_3(:,m)',TA', parents_4(:,m)','LineWidth',1)
legend({'Most upstream stage pair','Second upstream stage pair','Third upstream stage pair','Most downstream stage pair'},'Location','southeast')
xlim([0 T1])
ylim([1/12 1])
title('K=12')
xlabel('Trade Costs')
ylabel('Share of Filial Nodes with the Same Location')


% M=4
m=4;
subplot(2,2,m)
p=plot(TA', parents_1(:,m)',TA', parents_2(:,m)',TA', parents_3(:,m)',TA', parents_4(:,m)','LineWidth',1)
legend({'Most upstream stage pair','Second upstream stage pair','Third upstream stage pair','Most downstream stage pair'},'Location','southeast')
xlim([0 T1])
ylim([1/17 1])
title('K=17')
xlabel('Trade Costs')
ylabel('Share of Filial Nodes with the Same Location')


%set(h,'Units','Inches');
%pos = get(h,'Position');
%set(h,'PaperPositionMode','Auto','PaperUnits','Inches','PaperSize',[pos(3), pos(4)])
%print(h,'C:\Users\vtya5450\Dropbox (Sydney Uni)\AEJ_Revision\Figures\Figure A3','-dpdf','-r0')

hold off

