clear
tic

% Order
N=2;
%Length
M=5;
% Number of countries
K=2;

% Shape parameter
shape=4.12;
% Trade costs
T=0.2;
% Iceberg trade costs indicator
iceberg=1;

% Number of simulations
S1=100;
S2=1000;


% Boundaries of trade costs
T0=0;
T1=1;
% Number of steps
ST=100;
TA=zeros(ST,1);

%Parents

tshares=zeros(M-1,S1,ST);
for j=1:S1
shares=zeros(M-1,S2,ST);
for i=1:S2
costs=cell(M,1);
for m=1:M
    x=rand(N^(m-1),K);
    x=1./((-log(x)).^(-1/shape));
    costs{m}=x;
end
for t=1:ST
T=T0+((T1-T0)/ST)*(t-1);
shares(:,i,t)=fo_parents(N,M,K,T,iceberg,costs);
TA(t)=T;
end
end
tshares(:,j,:)=mean(shares,2);
progressbar(j/S1);
end
parents=squeeze(mean(tshares,2));


% Grandparents
tshares=zeros(M-2,S1,ST);
for j=1:S1
shares=zeros(M-2,S2,ST);
for i=1:S2
costs=cell(M,1);
for m=1:M
    x=rand(N^(m-1),K);
    x=1./((-log(x)).^(-1/shape));
    costs{m}=x;
end
for t=1:ST
T=T0+((T1-T0)/ST)*(t-1);
shares(:,i,t)=fo_grandchildren(N,M,K,T,iceberg,costs);
TA(t)=T;
end
end
tshares(:,j,:)=mean(shares,2);
progressbar(j/S1);
end
grandparents=squeeze(mean(tshares,2));


% Greatgrandparents
tshares=zeros(M-3,S1,ST);
for j=1:S1
shares=zeros(M-3,S2,ST);
for i=1:S2
costs=cell(M,1);
for m=1:M
    x=rand(N^(m-1),K);
    costs{m}=x;
end
for t=1:ST
T=T0+((T1-T0)/ST)*(t-1);
shares(:,i,t)=fo_greatgrandchildren(N,M,K,T,iceberg,costs);
TA(t)=T;
end
end
tshares(:,j,:)=mean(shares,2);
progressbar(j/S1);
end
greatgrandparents=squeeze(mean(tshares,2));


% Sisters
tshares=zeros(M-1,S1,ST);
for j=1:S1
shares=zeros(M-1,S2,ST);
for i=1:S2
costs=cell(M,1);
for m=1:M
    x=rand(N^(m-1),K);
    x=1./((-log(x)).^(-1/shape));

    costs{m}=x;
end
for t=1:ST
T=T0+((T1-T0)/ST)*(t-1);
shares(:,i,t)=fo_sisters(N,M,K,T,iceberg,costs);
TA(t)=T;
end
end
tshares(:,j,:)=mean(shares,2);
progressbar(j/S1);
end
sisters=squeeze(mean(tshares,2));


% Cousins
tshares=zeros(M-1,S1,ST);
for j=1:S1
shares=zeros(M-1,S2,ST);
for i=1:S2
costs=cell(M,1);
for m=1:M
    x=rand(N^(m-1),K);
    x=1./((-log(x)).^(-1/shape));
    costs{m}=x;
end
for t=1:ST
T=T0+((T1-T0)/ST)*(t-1);
shares(:,i,t)=fo_cousins(N,M,K,T,iceberg,costs);
TA(t)=T;
end
end
tshares(:,j,:)=mean(shares,2);
progressbar(j/S1);
end
cousins=squeeze(mean(tshares,2));

tshares=zeros(M-1,S1,ST);
for j=1:S1
shares=zeros(M-1,S2,ST);
for i=1:S2
costs=cell(M,1);
for m=1:M
    x=rand(N^(m-1),K);
    x=1./((-log(x)).^(-1/shape));

    costs{m}=x;
end
for t=1:ST
T=T0+((T1-T0)/ST)*(t-1);
shares(:,i,t)=fo_nieces(N,M,K,T,iceberg,costs);
TA(t)=T;
end
end
tshares(:,j,:)=mean(shares,2);
progressbar(j/S1);
end
nieces=squeeze(mean(tshares,2));




toc


hold on
h=figure;

fig=gcf;
fig.Units='normalized';
fig.OuterPosition=[0 0 1 1];
subplot(2,3,m)



% Children
m=1;
subplot(2,3,m)
p=plot(TA', parents(1,:)',TA', parents(2,:)',TA',parents(3,:)',TA', parents(4,:)','LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Third upstream stage','Most downstream stage'},'Location','southeast')
xlim([0 T1])
title('Children')
xlabel('Trade Costs')
ylabel('Share of Related Nodes with the Same Location')

% Grandhildren
m=2;
subplot(2,3,m)
p=plot(TA', grandparents(1,:)',TA', grandparents(2,:)',TA',grandparents(3,:)','LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Most downstream stage'},'Location','southeast')
xlim([0 T1])
title('Grandchildren')
xlabel('Trade Costs')
ylabel('Share of Related Nodes with the Same Location')


% Greatgrandchildren
m=3;
subplot(2,3,m)
p=plot(TA', greatgrandparents(1,:)',TA', greatgrandparents(2,:)','LineWidth',1)
legend({'Upstream stage','Downstream stage'},'Location','southeast')
xlim([0 T1])
title('Greatgrandchildren')
xlabel('Trade Costs')
ylabel('Share of Related Nodes with the Same Location')


% Sisters
m=4;
subplot(2,3,m)
p=plot(TA', sisters(1,:)',TA', sisters(2,:)',TA',sisters(3,:)',TA', sisters(4,:)','LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Third upstream stage','Most downstream stage'},'Location','southeast')
xlim([0 T1])
title('Sisters')
xlabel('Trade Costs')
ylabel('Share of Related Nodes with the Same Location')


% Cousins
m=5;
subplot(2,3,m)
p=plot(TA', cousins(1,:)',TA', cousins(2,:)',TA',cousins(3,:)','LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Most downstream stage'},'Location','southeast')
xlim([0 T1])
title('Cousins')
xlabel('Trade Costs')
ylabel('Share of Related Nodes with the Same Location')


% Nieces
m=6;
subplot(2,3,m)
p=plot(TA', nieces(4,:)',TA', nieces(3,:)',TA',nieces(2,:)',TA', nieces(1,:)','LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Third upstream stage','Most downstream stage'},'Location','southeast')
xlim([0 T1])
title('Nieces')
xlabel('Trade Costs')
ylabel('Share of Related Nodes with the Same Location')



%set(h,'Units','Inches');
%pos = get(h,'Position');
%set(h,'PaperPositionMode','Auto','PaperUnits','Inches','PaperSize',[pos(3), pos(4)])
%print(h,'C:\Users\vtya5450\Dropbox (Sydney Uni)\AEJ_Revision\Figures\Figure A4','-dpdf','-r0')

hold off
