clear

% Order
N=2;
% Length
M=5;
% Number of countries
K=2;
% Iceberg trade costs indicator
iceberg=1;
% Number of simulations
S=100000;
% Boundaries of trade costs
T0=0;
T1=2;
% Number of steps
ST=40;

% Largest number of countries
K0=32;
RSHR_K=zeros(M,K0-1);
XK=zeros(K0-1,1);
for k=2:K0
    K=k
    RSHR_K(:,k-1)=f_reshoring_upper(N,M,K,T0,T1,ST,S,iceberg);
    XK(k-1)=k;
end

N=2;
M=5;
K=2;

% Longest chain
 M0=10;
 RSHR_M=zeros(M0-1,M0-1);
 XM=zeros(M0-1,1);
 parfor m=2:M0
     M=m
 RSHR_M(1:m,m-1)=f_reshoring_upper(N,M,K,T0,T1,ST,S,iceberg);
 XM(m-1)=m;
 end
 

 N=2;
M=5;
K=2;


 % Highest order
  N0=10;
 XN=zeros(N0,1);
 RSHR_N=zeros(M,N0);
 RSHR_N(:,1)=f_reshoring_upper_N1(1,M,K,T0,T1,ST,S,iceberg);
 XN(1)=1;
 parfor n=2:N0
     N=n
     RSHR_N(:,n)=f_reshoring_upper(N,M,K,T0,T1,ST,S,iceberg);
     XN(n)=n;
 end
 
 
 RSHR_M(RSHR_M==0)=NaN;

RSHR_M(1,1)=0;
RSHR_M(2,1)=0;

DOWN=zeros(1,9);





for i=1:9
    DOWN(i)=RSHR_M(i+1,i);
end

hold on
h=figure;

fig=gcf;
fig.Units='normalized';
fig.OuterPosition=[0 0 1 1];







m=1;
subplot(3,1,m)
p=plot(XN', RSHR_N(1,:),XN', RSHR_N(2,:),XN', RSHR_N(3,:),XN', RSHR_N(4,:),XN', RSHR_N(5,:),'LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Third upstream stage','Fourth upstream stage','Most downstream stage'},'Location','southeast')
xlim([0 N0])
title('Order of a Tree')
xlabel('Order of a Tree')
ylabel('Share of Nodes Where Reshoring Happened')

m=2;
subplot(3,1,m)
p=plot(XM', RSHR_M(1,:),XM', RSHR_M(2,:),XM', RSHR_M(3,:),XM', RSHR_M(4,:),XM', RSHR_M(5,:),XM', RSHR_M(6,:),XM', RSHR_M(7,:),XM', RSHR_M(8,:),XM', RSHR_M(9,:),XM', RSHR_M(10,:),XM',DOWN,'r x','LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Third upstream stage','Fourth upstream stage','Fifth upstream stage','Sixth upstream stage','Seventh upstream stage','Eighth upstream stage','Most downstream stage',},'Location','southeast')
xlim([0 M0])
title('Length of a Tree')
xlabel('Length of a Tree')
ylabel('Share of Nodes Where Reshoring Happened')

m=3;
subplot(3,1,m)
p=plot(XK', RSHR_K(1,:),XK', RSHR_K(2,:),XK', RSHR_K(3,:),XK', RSHR_K(4,:),XK', RSHR_K(5,:),'LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Third upstream stage','Fourth upstream stage','Most downstream stage'},'Location','southeast')
xlim([0 K0])
title('Number of Countries')
xlabel('Number of Countries')
ylabel('Share of Nodes Where Reshoring Happened')



%set(h,'Units','Inches');
%pos = get(h,'Position');
%set(h,'PaperPositionMode','Auto','PaperUnits','Inches','PaperSize',[pos(3), pos(4)])


%print(h,'C:\Users\vtya5450\Dropbox (Sydney Uni)\AEJ_Revision\Figures\Figure A5','-dpdf','-r0')

hold off