function [path Vpath]=procedure_N1(costs,T,iceberg)

costs=cell2mat(costs);

M=size(costs,1);
K=size(costs,2);
N=1;

% Store the results in cell arrays:
Vvalues=zeros(M,K);
locations=zeros(M,K);



% Stage 1

costs1=costs(M,:);

% Now the choice has to be made for every state of the world (production
% location on the next stage)

costs13d=repmat(costs1,K,1);



% First, we'll need a decision matrix. It'll be an indicator matrix of the
% same dimensions as costs and will reflect which elements of costs matrix
% are active

% Tind is just a diagonal matrix that indicates that trade costs are
% (in)active. I want it to align with the dimensions of costs, so I repeat
% it in part and stage dimensions


Tind=eye(K);

% First parts. Minimum finds the value of the value function V and the
% index of the country to be chosen under any state of the world
[V,country_index]=min(costs13d+costs13d.*T.*(1-Tind).*iceberg+T.*(1-Tind).*(1-iceberg),[],2);


Vvalues(1,:)=V;
locations(1,:)=country_index;


% Stage i:

for i=2:M-1

costs1=costs(M+1-i,:);

costs13d=repmat(costs1,K,1);


[V,country_index]=min(Vvalues(i-1,:)+costs13d+(Vvalues(i-1,:)+costs13d).*T.*(1-Tind).*iceberg+T.*(1-Tind).*(1-iceberg),[],2);


Vvalues(i,:)=V;
locations(i,:)=country_index;
end

% At the last stage there's no need to sum up value functions for the next
% stage, this is the only difference

% Stage M
% At the final stage the decision is not conditional on the location at the next stage.
% Trade costs are already accounted in the previous stage’s value function


[V,country_index]=min(Vvalues(M-1,:)+costs(M,:),[],2);




% Now when we know the production location at the final stage, we can
% construct the optimal path and corresponding values of the value function
path=cell(M,1);
Vpath=cell(M,1);

loc0=country_index;

path{M}=country_index;
Vpath{M}=V;



for i=1:M-1
    loc0=locations(M-i,:);
    loc1=cell2mat(path(M+1-i));
    val0=Vvalues(M-i,:);
    
        path0=loc0(:,loc1);
        Vpath0=val0(:,loc1);
        
    

    path{M-i}=path0;
    Vpath{M-i}=Vpath0;
    
end

end
