clear
tic

for k=1:4
% Order
N=2;
% Length
M=1+k;
% Number of countries
K=2;

% Shape parameter
shape=4.12;
% Trade costs
T=0.2;
% Iceberg trade costs indicator
iceberg=1;

% Number of simulations
S1=100;
S2=1000;


% Smallest trade costs
T0=0;
% Largerst trade costs
T1=1;
% Number of steps in between
ST=100;
TA=zeros(ST,1);


volumeb=zeros(k,S2,ST);
volumea=zeros(k,S2,ST);

tvolumea=zeros(k,S1,ST);
tvolumeb=zeros(k,S1,ST);

tshares=zeros(M-1,S1,ST);
for j=1:S1
shares=zeros(M-1,S2,ST);
for i=1:S2
costs=cell(M,1);
for m=1:M
    x=rand(N^(m-1),K);
    x=1./((-log(x)).^(-1/shape));
    costs{m}=x;
end
for t=1:ST
Tb=T0+((T1-T0)/ST)*(t);
Ta=T0+((T1-T0)/ST)*(t-1);
% Trade volumes at every stage for trade costs Tb and Ta
volumeb(:,i,t)=f_elasticity(costs,Tb,iceberg);
volumea(:,i,t)=f_elasticity(costs,Ta,iceberg);
TA(t)=Tb;
end
end
tvolumea(:,j,:)=sum(volumea,2);
tvolumeb(:,j,:)=sum(volumeb,2);
progressbar(j/S1);
end

step=((T1-T0)/ST);
pTA=(TA-step)./TA-1;
pTA=repmat(pTA,1,M-1,S1);
pTA=permute(pTA,[2 3 1]);
pvolume=(tvolumeb-tvolumea)./tvolumea;
% Elasticities
elast=pvolume./pTA;
tshares=elast;

parents=mean(tshares,2);
k

parents5=prctile(tshares,5,2);
parents95=prctile(tshares,95,2);
results=[parents5 parents parents95];


parents_1(:,k)=squeeze(parents(1,:,:));
parents_2(:,k)=squeeze(parents(min(2,k),:,:));
parents_3(:,k)=squeeze(parents(min(3,k),:,:));
parents_4(:,k)=squeeze(parents(min(4,k),:,:));
parents_5(:,k)=squeeze(parents(min(5,k),:,:));
parents_6(:,k)=squeeze(parents(min(6,k),:,:));

end



hold on
h=figure;

fig=gcf;
fig.Units='normalized';
fig.OuterPosition=[0 0 1 1];


% N=1
n=1;
subplot(2,2,n)
p=plot(TA', parents_1(:,n)','LineWidth',1)
legend({'Upstream stage'},'Location','northwest')
xlim([0 T1])
title('N=2')
xlabel('Trade Costs')
ylabel('Elasticity')


% N=2
n=2;
subplot(2,2,n)
p=plot(TA', parents_1(:,n)',TA', parents_2(:,n)','LineWidth',1)
legend({'Upstream stage','Downstream stage'},'Location','northwest')
xlim([0 T1])
title('N=3')
xlabel('Trade Costs')
ylabel('Elasticity')


% N=3
n=3;
subplot(2,2,n)
p=plot(TA', parents_1(:,n)',TA', parents_2(:,n)',TA', parents_3(:,n)','LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Most downstream stage'},'Location','northwest')
xlim([0 T1])
title('N=4')
xlabel('Trade Costs')
ylabel('Elasticity')


% N=4
n=4;
subplot(2,2,n)
p=plot(TA', parents_1(:,n)',TA', parents_2(:,n)',TA', parents_3(:,n)',TA', parents_4(:,n)','LineWidth',1)
legend({'Most upstream stage','Second upstream stage','Third upstream stage','Most downstream stage'},'Location','northwest')
xlim([0 T1])
title('N=5')
xlabel('Trade Costs')
ylabel('Elasticity')





%set(h,'Units','Inches');
%pos = get(h,'Position');
%set(h,'PaperPositionMode','Auto','PaperUnits','Inches','PaperSize',[pos(3), pos(4)])
%print(h,'C:\Users\vtya5450\Dropbox (Sydney Uni)\AEJ_Revision\Figures\Figure A9','-dpdf','-r0')

hold off
toc